//
//  ContactsBook.swift
//  PhoneBook
//
//  Created by Santiago Pavón Gómez on 30/11/16.
//  Copyright © 2016 UPM. All rights reserved.
//

import Foundation

class ContactsBook {
    
    // Contiene los contactos.
    var contacts: [Contact]
    
    init() {
        contacts = []
        
        // Añado unos contactos inventados solo para probar.
        let c1 = Contact(name: "Pedro García",
                         address: "Calle del Gato, 25",
                         phone: "111222333")
        let c2 = Contact(name: "Ana López",
                         address: "Calle del Loro, 12",
                         phone: "987654321")
        let c3 = Contact(name: "Alex Grease",
                         address: "Calle del Mosquito, 2",
                         phone: "101010101")
        contacts += [c1, c2, c3]
    }
    
    func loadOrCreate(from filename: String) {
        
        // Path
        let docsPath = NSSearchPathForDirectoriesInDomains(
            .documentDirectory, .userDomainMask, true)[0] as NSString
        let filePath = docsPath.appendingPathComponent(filename)
        
        // Lee el fichero en un Data, y extrae el array de contactos
        if let data = NSData(contentsOfFile: filePath) as? Data,
            let contacts = NSKeyedUnarchiver.unarchiveObject(with: data) as? [Contact] {
            self.contacts = contacts
        } else {
            contacts = []  // Fallo en la extraccion o al cargar el fichero
        }
    }
    
    func save(to filename: String) {
        
        // Path
        let docsPath = NSSearchPathForDirectoriesInDomains(
            .documentDirectory, .userDomainMask, true)[0] as NSString
        let filePath = docsPath.appendingPathComponent(filename)
        
        // Convierte contacts en un Data
        let data = NSKeyedArchiver.archivedData(withRootObject: contacts)
        
        // Salva el Data en un fichero
        let url = URL(fileURLWithPath: filePath)
        //data.writeToFile(filePath, atomically:true)
        try? data.write(to: url, options: .atomic)
    }
    
    
    
    
    
}
    
